program sc;
(*$M 4096,0,70000 *)
(*
  Copyright (c) 1995-2000 Peter Sieg, Rabishauerstr.9, 37603 Holzminden
  Program under GNU GPL Version 2 or higher
  Greeting to Heike, Robin and Janis
*)
uses dos,crt(*,tmouse*);

const
cmin               =  97;
cmid               =  104;
cmax               =  112;
rmin               =  1;
rmax               =  60;
cr                 =  #13;
bs                 =  #8;

type
str80              =  string[80];
str40              =  string[40];
celltype           =  record
                        s : str40;
                        v : real;
                      end;
sheettype          =  array[cmin..cmax,rmin..rmax] of celltype;
sheetptr           =  ^sheettype;

var
sheet              :  sheetptr;
filename           :  str80;
s                  :  str80;
i,ii,j,jj,
x_off,y_off,
p,errnum           :  integer;
f                  :  file of sheettype;
t                  :  text;
key                :  char;
c_pos,r_pos        :  integer; (* position of active cell *)
mono               :  boolean;

function exist(n : str80) : boolean;
var
f                  : file;
begin
  assign (f,n);
  (*$I-*)
  reset (f);
  errnum           := ioresult;
  (*$I+*)
  if errnum = 0 then close (f);
  exist            := (errnum = 0);
end;
(*
function wherex : integer;
begin
  wherex := 6;
end;
function wherey : integer;
begin
  wherey := 2;
end;
function readkey : char;
var c : char;
begin
  read(Kbd,c);
  readkey := c;
end;
procedure textcolor(c : integer);
begin end;
procedure textbackground(c : integer);
begin end;
*)
procedure read_str(VAR s : str80; l : integer);
var
i, j, x, y         :  integer;
begin
  i                := length(s);
  x                := wherex;
  y                := wherey;
  gotoxy (x,y);
  write  (s);
  for j            := i + 1 to l do write  ('_');
  repeat
    repeat
      gotoxy (x + i,y);
      (*read(kbd,key);*)
      key          := readkey;
    until (key = #13) or (key = #8) or (key in [#32..#255]);
    if ((key > #31) and (i < l)) then
    begin
      i := i + 1;
      s            := s + key;
      write  (key);
    end
    else
    begin
      if (key = #8) and (i > 0) then
      begin
        i := i - 1;
        delete(s,length(s),1);
        gotoxy (x + i,y);
        write  ('_');
      end;
    end;
  until (key = #13);
end;
{ -------- bagles ----------- }
procedure bagles;

const
Bell                     :  char = #7;

var
i,j,
Zahl,
Versuch                  :  integer;
Taste                    :  char;
MeineZahl,DeineZahl      :  string(.3.);


function ZufallsZiffer   :  integer;
(*
Gibt eine zufaellige Ziffer zwischen 1 und 9 zurueck
*)

var
x                        :  integer;

begin
  x                      := random(9);
  x                      := succ(x);
  ZufallsZiffer          := x;
end;

function ZufallsZahl     :  integer;
(*
Gibt eine dreistellige Zufallszahl ohne Nullen und doppelte Ziffern zurueck
*)

var
Ziffer1,Ziffer2,
Ziffer3                  :  integer;

begin
  Ziffer1                := ZufallsZiffer;

  repeat
    Ziffer2              := ZufallsZiffer;
  until Ziffer2 <> Ziffer1;

  repeat
    Ziffer3              := ZufallsZiffer;
  until ((Ziffer3 <> Ziffer2) and (Ziffer3 <> Ziffer1));

  ZufallsZahl            := Ziffer3*100+Ziffer2*10+Ziffer1;

end;


begin
  repeat
    if not mono then
    begin
      textcolor(white);
      textbackground(red);
    end;
    clrscr;
    writeln('Bagles, ich denke mir eine dreistellige Zahl ohne doppelte');
    writeln('Ziffern und ohne Nullen aus; Du musst diese Zahl erraten.');
    writeln('Fuer eine richtige Ziffer an falscher Stelle gebe ich PICO');
    writeln('aus; Fuer eine richtige Ziffer an richtiger Stelle gebe ich');
    writeln('FERMI aus. Okay, ich habe mir eine Zahl ausgedacht...');

    randomize;

    Zahl                 := ZufallsZahl;

    str(Zahl:3,MeineZahl);

    Versuch              := 1;
    repeat
      (*$i-*)
      repeat
        writeln;
        write  ('Versuch ',Versuch:2,' : ');
        readln (Zahl);
      until ((Zahl > 122) and (Zahl < 988) and (ioresult = 0));
      (*$i+*)

      str(Zahl:3,DeineZahl);

      for i              := 1 to 3 do
      begin
        if DeineZahl[i] = MeineZahl[i] then write  ('FERMI ')
        else
        begin
          for j          := 1 to 3 do
          begin
            if DeineZahl[j] = MeineZahl[i] then write  ('PICO ');
          end;
        end;
      end;

      Versuch            := succ(Versuch);

    until DeineZahl = MeineZahl;

    writeln;
    writeln(Bell);
    writeln('Geschafft, Du hast die richtige Zahl gefunden.');
    write  ('Nocheinmal ? ');
    repeat
      repeat
      until keypressed;
      Taste            := readkey;
      (*read(kbd,taste);*)
      Taste              := upcase(Taste);
    until (Taste in ['J','N']);

  until Taste <> 'J';
  (*
  textcolor(white);
  textbackground(black);
  *)
end;

{ -------- calculator ------- }
function re(a:str80):real;
var b:str80;
op,oper: char;
dummy,kla,i: integer;
er,wer,wert: real;
sw: boolean;
begin
  kla:=0;oper:='+';i:=1;;wert:=0;er:=0;
  while i<=length(a) do
  begin
    if oper in ['+','-'] then wert:=wert+er;
    b:='';
    repeat
      if a[i]='(' then kla:=kla+1;
      if a[i]=')' then kla:=kla-1;
      sw:=(a[i] in ['+','-','*','/']) and (kla=0);
      if not sw then b:=b+a[i];
      i:=i+1;
    until (i>length(a)) or sw;
    op:=oper;oper:=a[i-1];
    if b[1]='(' then wer:=re(copy(b,2,length(b)-2))
    else val(b,wer,dummy);
    if b<' ' then wer:=0;
    case op of
      '+':er:=wer; '-':er:=-wer;
      '*':er:=er*wer; '/':if wer<>0 then er:=er/wer else er:=0;
    end;
  end;
  re:=wert+er;
end;


function _re(s : str80):real;
var b : str80;
p : integer;
begin
  repeat  (* dereference cell address $xnn to values *)
  p:=pos('$',s);
  if p>0 then
  begin
    ii:=ord(s[p+1]);
    val(copy(s,p+2,2),jj,errnum);
    delete(s,p,4);
    if (ii in [cmin..cmax]) and (jj in [rmin..rmax]) and (errnum=0)
    then str(sheet^[ii,jj].v:0:2,b)
    else b:='0';
    insert(b,s,p);
  end;
  until p<1;
  _re:=re(s);
end;

procedure calc;
var r : real;
begin
r := 0.0;
repeat
  gotoxy(1,2); write('calc [',r:12:3,'] >'); clreol; readln(s);  r:=r+_re(s);
until length(s)<1;
gotoxy(1,2); clreol;
end;

procedure init;
begin
c_pos :=cmin;
r_pos :=rmin;
x_off := 0; y_off := 0;
for i := cmin to cmax do
  for j := 1 to rmax do
  begin
    sheet^[i,j].s := '';
    sheet^[i,j].v := 0.0;
  end;
end;

procedure upd_cell(ix,jx,i,j,n : integer);
var s,b : str80;
p : integer;
begin
  s:=sheet^[i,j].s;
  repeat  (* change cell address $xnn to +/- *)
  p:=pos('$',s);
  if p>0 then
  begin
    ii:=ord(s[p+1]); (* char a=cmin=97-p=cmax=112 *)
    val(copy(s,p+2,2),jj,errnum);  (* val=01-60   *)
    delete(s,p,4);                 (* remove $xnn *)
    if (ii in [cmin..cmax]) and (jj in [rmin..rmax]) and (errnum=0)
    then begin
(*
    n=0 = chr - 1 = c->b; h->g
    n=1 = chr + 1 = c->d; h->i
    n=2 = val - 1 = 12->11; 07->06;
    n=3 = val + 1 = 12->13; 07->08;
*)
    if n=0 then if ix<ii then ii := ii - 1;
    if n=1 then if ix<=ii then ii := ii + 1;
    if n=2 then if jx<jj then jj := jj - 1;
    if n=3 then if jx<=jj then jj := jj + 1;
    if ii < cmin then ii:=cmin;
    if ii > cmax then ii:=cmax;
    if jj < rmin then jj:=rmin;
    if jj > rmax then jj:=rmax;
    str(jj:2,b);
    insert('%x',b,1);
    b[2]:=chr(ii);
    insert(b,s,p);   (* insert new $xnn *)
    end;
  end;
  until p<1;
  (* now change all % back to $ !!!*)
  repeat
  p:=pos('%',s);
  if p>0 then
  begin
    delete(s,p,1);          (* remove % *)
    insert('$',s,p);        (* insert $ *)
  end;
  until p<1;
  sheet^[i,j].s:=s;

end;


procedure calc_cell(i,j : integer);
begin
  sheet^[i,j].v:=0.0;
  if sheet^[i,j].s[1]<>'.' then
  begin
    if sheet^[i,j].s[1]='X' then
    begin
      if sheet^[i,j].s[2]='<' then
      begin
        sheet^[i,j].v:=99999999.9;
        for ii:=i-1 downto cmin do
          if (sheet^[ii,j].v<sheet^[i,j].v) and (sheet^[ii,j].v<>0.0) then
            sheet^[i,j].v:=sheet^[ii,j].v;
      end
      else if sheet^[i,j].s[2]='>' then
      begin
        sheet^[i,j].v:=-99999999.9;
        for ii:=i-1 downto cmin do
          if sheet^[ii,j].v>sheet^[i,j].v then sheet^[i,j].v:=sheet^[ii,j].v;
      end
      else for ii:=i-1 downto cmin do
      begin
        if sheet^[ii,j].s[1]='X' then exit (*ii := cmin*)
        else sheet^[i,j].v:=sheet^[i,j].v+sheet^[ii,j].v;
      end;
    end
    else if sheet^[i,j].s[1]='Y' then
    begin
      if sheet^[i,j].s[2]='<' then
      begin
        sheet^[i,j].v:=99999999.9;
        for jj:=j-1 downto rmin do
          if (sheet^[i,jj].v<sheet^[i,j].v) and (sheet^[i,jj].v<>0.0) then
            sheet^[i,j].v:=sheet^[i,jj].v;
      end
      else if sheet^[i,j].s[2]='>' then
      begin
        sheet^[i,j].v:=-99999999.9;
        for jj:=j-1 downto rmin do
          if sheet^[i,jj].v>sheet^[i,j].v then sheet^[i,j].v:=sheet^[i,jj].v;
      end
      else for jj:=j-1 downto rmin do
      begin
        if sheet^[i,jj].s[1]='Y' then exit (*jj := rmin*)
        else sheet^[i,j].v:=sheet^[i,j].v+sheet^[i,jj].v;
      end;
    end
    else sheet^[i,j].v := _re(sheet^[i,j].s);
  end;
end;

procedure disp_cell(i,j : integer);
begin
  if (i=c_pos) and (j=r_pos) then (* active cell; use different color *)
  begin
    (*HighVideo;*)
    if mono then highvideo
    else begin
    textbackground(red);
    textcolor(yellow);
    end;
    gotoxy((i-cmin-x_off)*10+1,j-y_off+3); write('>         ');
    if length(sheet^[i,j].s)>0 then
    begin
      gotoxy((i-cmin-x_off)*10+1,j-y_off+3);
      if sheet^[i,j].s[1]='.' then write('>',copy(sheet^[i,j].s,2,9))
      else begin
        (*calc_cell(i,j);*) write('>',sheet^[i,j].v:9:2); end;
    end;
    (*LowVideo;*)
    if mono then lowvideo
    else begin
    textbackground(white);
    textcolor(black);
    end;
  end
  else
  begin
    if not mono then
    begin
      if (j mod 2) = 0 then textbackground(white)
      else textbackground(lightgreen);
    end;
    gotoxy((i-cmin-x_off)*10+1,j-y_off+3); write('          ');
    if length(sheet^[i,j].s)>0 then
    begin
      gotoxy((i-cmin-x_off)*10+1,j-y_off+3);
      if sheet^[i,j].s[1]='.' then write(copy(sheet^[i,j].s,2,10))
      else begin
        (*calc_cell(i,j);*) write(sheet^[i,j].v:10:2); end;
    end;
    if mono then lowvideo
    else begin
    textbackground(white);
    textcolor(black);
    end;
  end;
end;

procedure display;
begin
if not mono then begin
textbackground(white);
textcolor(black);
end;
clrscr;
for i := cmin to cmax do
  for j := rmin to rmax do calc_cell(i,j);
for i := cmin+x_off to cmid+x_off do
  for j := rmin+y_off to 20+y_off do disp_cell(i,j);
end;

procedure insrow;
var n,i,j : integer;
    s : str80;
begin
  n:=r_pos;
  for i:= rmax-1 downto n do
    for j:= cmin to cmax do
    begin
      sheet^[j,i+1].s := sheet^[j,i].s;
      sheet^[j,i+1].v := sheet^[j,i].v;
      upd_cell(cmax,n,j,i+1,3);
    end;
  for j:= cmin to cmax do
  begin
    sheet^[j,n].s := '';
    sheet^[j,n].v := 0.0;
  end;
  display; { display; }
end;

procedure inscol;
var n,i,j : integer;
    s : str80;
begin
  n:=c_pos;
  for j:= cmax-1 downto n do
    for i:= rmin to rmax do
    begin
      sheet^[j+1,i].s := sheet^[j,i].s;
      sheet^[j+1,i].v := sheet^[j,i].v;
      upd_cell(n,rmax,j+1,i,1);
    end;
  for i:= rmin to rmax do
  begin
    sheet^[n,i].s := '';
    sheet^[n,i].v := 0.0;
  end;
  display; { display; }
end;

procedure delrow;
var n,i,j : integer;
    s : str80;
begin
  n:=r_pos;
  for i:= n to rmax-1 do
    for j:= cmin to cmax do
    begin
      sheet^[j,i].s := sheet^[j,i+1].s;
      sheet^[j,i].v := sheet^[j,i+1].v;
      upd_cell(cmax,n,j,i,2);
    end;
  for j:= cmin to cmax do
  begin
    sheet^[j,rmax].s := '';
    sheet^[j,rmax].v := 0.0;
  end;
  display; { display; }
end;

procedure delcol;
var n,i,j : integer;
    s : str80;
begin
  n:=c_pos;
  for j:= n to cmax-1 do
    for i:= rmin to rmax do
    begin
      sheet^[j,i].s := sheet^[j+1,i].s;
      sheet^[j,i].v := sheet^[j+1,i].v;
      upd_cell(n,rmax,j,i,0);
    end;
  for i:= rmin to rmax do
  begin
    sheet^[cmax,i].s := '';
    sheet^[cmax,i].v := 0.0;
  end;
  display; { display; }
end;


procedure help;
begin
  if not mono then begin
  textbackground(yellow);
  textcolor(black);
  end;
  clrscr;
  writeln('Help Page:  (Access with ? or H elp)'); writeln;
  writeln;
  writeln('cmd> ^ (k)  = dec active row.      |  v (j)  = inc active row.');
  writeln('cmd> < (h)  = dec active col.      |  > (l)  = inc active col.');
  writeln('cmd> 1. move cursor to destination.   2. Press ! (a) to edit cell.');
  writeln('cmd>  I/i   = insert col/row.      |   D/d   = delete col/row.');
  writeln('cmd>  L oad = load spreadsheet.    |   s ave = save spreadsheet.');
  writeln('cmd>  export= export to sc/unix.   |   Export= export to CSV(;).');
  writeln('cmd>  p rint= print spreadsheet.   |  e  x it= exit program.');
  writeln('     .P rint= print for multipage. |   c alc = calculator.');
  writeln('     (page 1= cols a-h X rows 1-60 |  page 2 = cols i-p X rows 1-60)');
  writeln;
  writeln('str> <cell string>  = 0-9 +-/* <cell ref> X/Y .text...');
  writeln('      example       = 26.12*$b02+1963      /  .this=text...');
  writeln('     <cell ref>     = $a-p01-60 (must be 4 characters long)');
  writeln('     X              = Sum of cols before cell downto a or X');
  writeln('     Y              = Sum of rows before cell downto 1 or Y');
  writeln('     X/Y</>         = <=Min Value; >=Max Value of cells downto 1');
  writeln;
  gotoxy(1,3);
  readln(s); clrscr; display;
end;

procedure print_cell(i,j : integer);
var s:string;
begin
  if length(sheet^[i,j].s)>0 then
  begin
  if sheet^[i,j].s[1]='.' then
  begin
    s:=copy(sheet^[i,j].s,2,10);
    while length(s)<10 do s:=s+' ';
    write(t,s);
  end
  else begin
  calc_cell(i,j); write(t,sheet^[i,j].v:10:2); end;
  end else write(t,'          ');
end;

procedure csv_cell(i,j : integer);
begin
  if length(sheet^[i,j].s)>0 then
  begin
  if sheet^[i,j].s[1]='.' then write(t,copy(sheet^[i,j].s,2,10):10)
  else begin
  calc_cell(i,j); write(t,sheet^[i,j].v:10:2); end;
  end; (*else write(t,'          ');*)
  write(t,';');
end;

procedure export_cell(i,j : integer);
var cellname : str80;
begin
  if length(sheet^[i,j].s)>0 then
  begin
  str(j,cellname); insert(' ',cellname,1); cellname[1]:=chr(i);
  if sheet^[i,j].s[1]='.' then writeln(t,'label ',cellname,' = "',copy(sheet^[i,j].s,2,10):10,'"')
  else begin
  calc_cell(i,j); writeln(t,'let ',cellname,' = ',sheet^[i,j].v:10:2); end;
  end (*else write(t,'          ');*)
end;

procedure save_cell(i,j : integer);
var cellname : str80;
begin
  if length(sheet^[i,j].s)>0 then
  begin
  str(j:2,cellname); insert(' ',cellname,1); cellname[1]:=chr(i);
  if cellname[2]=' ' then cellname[2]:='0';
  writeln(t,cellname,'=',sheet^[i,j].s);
  end;
end;

procedure export;
begin
assign(t,'sc.ux');
rewrite(t);
for j := 1 to rmax do
begin
  for i := cmin to cmax do
    export_cell(i,j);
end;
close (t);
end;

procedure csv;
begin
assign(t,'sc.csv');
rewrite(t);
for j := 1 to rmax do
begin
  for i := cmin to cmax do
    csv_cell(i,j);
  writeln(t);
end;
close (t);
end;

procedure save;
begin
assign(t,filename);
rewrite(t);
for j := 1 to rmax do
begin
  for i := cmin to cmax do
    save_cell(i,j);
end;
close (t);
end;

procedure print(mp : boolean);
begin
assign(t,'sc.prn');
rewrite(t);
for j := 1 to rmax do
begin
  for i := cmin to cmid do (* Page one *)
    print_cell(i,j);
  writeln(t);
end;
if mp then for i:= 1 to 70 do writeln(t)
else writeln(t,#12); (* FF Formfeed *)
for j := 1 to rmax do
begin
  for i := 105 to cmax do (* Page two *)
    print_cell(i,j);
  writeln(t);
end;
if not mp then writeln(t,#12); (* FF Formfeed *)
close (t);
end;

procedure load;
begin
  init;
  clrscr;
  writeln('Inside sheet:     Press ?/h for help.');
  writeln('Normal operation: Move cursor with hjkl. Press a to edit cell.');
  write('Filename: '); readln(filename);
  if exist(filename) then
  begin
    assign(t,filename);
    reset(t);
    while not eof(t) do
    begin
      readln(t,s);
      val(copy(s,2,2),j,i);
      if (i=0) and (j in [rmin..rmax]) then i := ord(s[1]);
      if (i in [cmin..cmax]) then (* valid cell address entered; get string *)
        sheet^[i,j].s := copy(s,5,78);
    end;
    close (t);
  end;
  display;
end;

procedure my_readln;
var s : str80;
    btn:byte;
    x,y:integer;
begin
  btn:=0;
  (*read(kbd,key);*)
  (*
  repeat
   if MouseInstalled then btn:=GetButton;
  until (btn>0) or keypressed;
  if btn>0 then
  begin
   GetMousePos(x,y);
   if y=1 then (* top menu line *)
   begin
    case (x) of
     80: key:='l';
     79: key:='h';
     78: key:='j';
     77: key:='k';
     76: key:='6';
     75: key:='5';
     74: key:='4';
     73: key:='3';
     72: key:='2';
     71: key:='1';
    end;
   end;
   if y>3 then * display area *
   begin
    c_pos:=cmin+(x div 10)+x_off;
    r_pos:=y+y_off-3;
    display;
   end;
  end
  else
  *)
  key:=readkey; if (key=#0) then key:=readkey;
  (*gotoxy(1,1); write(Ord(key),'->',key);*)
  case key of
  '1'     : begin c_pos:=c_pos-x_off; x_off:= 0; c_pos:=c_pos+x_off; r_pos:=r_pos-y_off; y_off:= 0; r_pos:=r_pos+y_off;
            display end;
  '2'     : begin c_pos:=c_pos-x_off; x_off:= 8; c_pos:=c_pos+x_off; r_pos:=r_pos-y_off; y_off:= 0; r_pos:=r_pos+y_off;
            display end;
  '3'     : begin c_pos:=c_pos-x_off; x_off:= 0; c_pos:=c_pos+x_off; r_pos:=r_pos-y_off; y_off:=20; r_pos:=r_pos+y_off;
            display end;
  '4'     : begin c_pos:=c_pos-x_off; x_off:= 8; c_pos:=c_pos+x_off; r_pos:=r_pos-y_off; y_off:=20; r_pos:=r_pos+y_off;
            display end;
  '5'     : begin c_pos:=c_pos-x_off; x_off:= 0; c_pos:=c_pos+x_off; r_pos:=r_pos-y_off; y_off:=40; r_pos:=r_pos+y_off;
            display end;
  '6'     : begin c_pos:=c_pos-x_off; x_off:= 8; c_pos:=c_pos+x_off; r_pos:=r_pos-y_off; y_off:=40; r_pos:=r_pos+y_off;
            display end;
  'v','j' : if (r_pos<rmax) then
        begin
          r_pos := r_pos + 1;
          if (r_pos< 20) then y_off:=0;
          if (r_pos> 20) then y_off:=20;
          if (r_pos> 40) then y_off:=40;
          display;
        end;
  '^','k' : if (r_pos>rmin) then
        begin
          r_pos := r_pos - 1;
          if (r_pos<=20) then y_off:=0;
          if (r_pos> 20) then y_off:=20;
          if (r_pos> 40) then y_off:=40;
          display;
        end;
  '>','l' : if (c_pos<cmax) then
        begin
          c_pos := c_pos + 1;
          if (c_pos> cmid) then x_off:=8;
          display;
        end;
  '<','h' : if (c_pos>cmin) then
        begin
          c_pos := c_pos - 1;
          if (c_pos<=cmid) then x_off:=0;
          display;
        end;
  '?',
  'H' : help;
  '@',
  '$',
  'B' : begin bagles; display; end;
  'i' : insrow;
  'd' : delrow;
  'I' : inscol;
  'D' : delcol;
  'L' : load;
  'c' : calc;
  'x',
  's' : save;
  'e' : export;
  'E' : csv;
  'p' : print(false);
(*'P' : print(true);*)
  '!','a' : begin (* F2 *)
          gotoxy(1,2);
          write('str> ');
          s:=sheet^[c_pos,r_pos].s;
          read_str(s,40);
          sheet^[c_pos,r_pos].s:=s;
          display;
        end;
  end;
end;

procedure work;
var rows,columns : string[20];
    n : integer;
begin
  repeat
    if x_off = 0 then columns:='Columns: A-H | '
    else columns:='Columns: I-P | ';
    case y_off of
       0: rows:='Rows:  1-20';
      20: rows:='Rows: 21-40';
      40: rows:='Rows: 41-60';
    end;
    if not mono then begin
    textbackground(blue);
    textcolor(white);
    end;
    gotoxy(1,1); write(columns,rows);
    write('  -  Active Cell: ',Upcase(Chr(c_pos)));
    if (r_pos<10) then write('0'); write(r_pos);
    write('  -  File: ',filename); clreol; gotoxy(71,1); write('123456^v<>'); writeln;
    for n:=0 to 7 do
    begin
      gotoxy(n*10+5,3); write(Upcase(Chr(cmin+x_off+n)));
    end;
    if not mono then begin
    textbackground(cyan);
    textcolor(black);
    end;
    gotoxy(1,2);
    write('cmd> ',sheet^[c_pos,r_pos].s); clreol; my_readln;
  until key='x';
end;


begin
new(sheet);
if exist('mono') then mono:=true
else mono:=false;
(*if MouseInstalled then SMouse;*)
load;
work;
(*dispose(sheet);*)
normvideo;
(*if MouseInstalled then HMouse;*)
clrscr;
end.


